package dev.shadowsoffire.apotheosis.mixin;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixInstance;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.SocketHelper;
import dev.shadowsoffire.apotheosis.ench.asm.EnchHooks;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.DoubleStream;
import javax.annotation.Nullable;
import net.minecraft.ChatFormatting;
import net.minecraft.core.registries.BuiltInRegistries;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.ListTag;
import net.minecraft.network.chat.CommonComponents;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.ComponentContents;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.Style;
import net.minecraft.network.chat.contents.TranslatableContents;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.util.RandomSource;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.ModifyVariable;
import org.spongepowered.asm.mixin.injection.Redirect;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(value = {ItemStack.class}, priority = 500)
public class ItemStackMixin {
  @Inject(method = {"getHoverName"}, at = {@At("RETURN")}, cancellable = true)
  public void apoth_affixItemName(CallbackInfoReturnable<Component> cir) {
    ItemStack ths = (ItemStack)this;
    CompoundTag afxData = ths.m_41737_("affix_data");
    if (afxData != null && afxData.m_128425_("name", 8))
      try {
        Component component = AffixHelper.getName(ths);
        ComponentContents componentContents = component.m_214077_();
        if (componentContents instanceof TranslatableContents) {
          TranslatableContents tContents = (TranslatableContents)componentContents;
          int idx = "misc.apotheosis.affix_name.four".equals(tContents.m_237508_()) ? 2 : 1;
          tContents.m_237523_()[idx] = cir.getReturnValue();
          cir.setReturnValue(component);
        } else {
          afxData.m_128473_("name");
        } 
      } catch (Exception exception) {
        afxData.m_128473_("name");
      }  
    DynamicHolder<LootRarity> rarity = AffixHelper.getRarity(afxData);
    if (rarity.isBound()) {
      MutableComponent mutableComponent = ((Component)cir.getReturnValue()).m_6881_().m_130938_(s -> s.m_131148_(((LootRarity)rarity.get()).getColor()));
      cir.setReturnValue(mutableComponent);
    } 
  }
  
  @ModifyVariable(at = @At(value = "INVOKE", target = "net/minecraft/world/item/ItemStack.getDamageValue()I"), method = {"hurt"}, argsOnly = true, ordinal = 0)
  public int swapDura(int amount, int amountCopy, RandomSource pRandom, @Nullable ServerPlayer pUser) {
    int blocked = 0;
    DoubleStream socketBonuses = SocketHelper.getGems((ItemStack)this).getDurabilityBonusPercentage(pUser);
    DoubleStream afxBonuses = AffixHelper.streamAffixes((ItemStack)this).mapToDouble(inst -> inst.getDurabilityBonusPercentage(pUser));
    DoubleStream bonuses = DoubleStream.concat(socketBonuses, afxBonuses);
    double chance = bonuses.reduce(0.0D, (res, ele) -> res + (1.0D - res) * ele);
    int delta = 1;
    if (chance < 0.0D) {
      delta = -1;
      chance = -chance;
    } 
    if (chance > 0.0D)
      for (int i = 0; i < amount; i++) {
        if (pRandom.m_188501_() <= chance)
          blocked += delta; 
      }  
    return amount - blocked;
  }
  
  private static void appendModifiedEnchTooltip(List<Component> tooltip, Enchantment ench, int realLevel, int nbtLevel) {
    MutableComponent mc = ench.m_44700_(realLevel).m_6881_();
    mc.m_7360_().clear();
    MutableComponent mutableComponent1 = Component.m_237115_("enchantment.level." + nbtLevel);
    MutableComponent mutableComponent2 = Component.m_237115_("enchantment.level." + realLevel);
    if (realLevel != 1 || EnchHooks.getMaxLevel(ench) != 1)
      mc.m_7220_(CommonComponents.f_263701_).m_7220_((Component)mutableComponent2); 
    int diff = realLevel - nbtLevel;
    char sign = (diff > 0) ? '+' : '-';
    MutableComponent mutableComponent3 = Component.m_237110_("(%s " + sign + " %s)", new Object[] { mutableComponent1, Component.m_237115_("enchantment.level." + Math.abs(diff)) }).m_130940_(ChatFormatting.DARK_GRAY);
    mc.m_7220_(CommonComponents.f_263701_).m_7220_((Component)mutableComponent3);
    if (realLevel == 0)
      mc.m_130940_(ChatFormatting.DARK_GRAY); 
    tooltip.add(mc);
  }
  
  @Redirect(method = {"getTooltipLines"}, at = @At(value = "INVOKE", target = "Lnet/minecraft/world/item/ItemStack;appendEnchantmentNames(Ljava/util/List;Lnet/minecraft/nbt/ListTag;)V"))
  public void apoth_enchTooltipRewrite(List<Component> tooltip, ListTag tagEnchants) {
    ItemStack ths = (ItemStack)this;
    Map<Enchantment, Integer> realLevels = new HashMap<>(ths.getAllEnchantments());
    List<Component> enchTooltips = new ArrayList<>();
    for (int i = tagEnchants.size() - 1; i >= 0; i--) {
      CompoundTag compoundtag = tagEnchants.m_128728_(i);
      Enchantment ench = (Enchantment)BuiltInRegistries.f_256876_.m_7745_(EnchantmentHelper.m_182446_(compoundtag));
      if (ench != null && realLevels.containsKey(ench)) {
        int nbtLevel = EnchantmentHelper.m_182438_(compoundtag);
        int realLevel = ((Integer)realLevels.remove(ench)).intValue();
        if (nbtLevel == realLevel) {
          enchTooltips.add(ench.m_44700_(EnchantmentHelper.m_182438_(compoundtag)));
        } else {
          appendModifiedEnchTooltip(enchTooltips, ench, realLevel, nbtLevel);
        } 
      } 
    } 
    Collections.reverse(enchTooltips);
    tooltip.addAll(enchTooltips);
    for (Map.Entry<Enchantment, Integer> real : realLevels.entrySet()) {
      if (((Integer)real.getValue()).intValue() > 0)
        appendModifiedEnchTooltip(tooltip, real.getKey(), ((Integer)real.getValue()).intValue(), 0); 
    } 
  }
}
